
import javafx.application.Application;
import javafx.fxml.FXMLLoader;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.layout.AnchorPane;
import javafx.stage.Stage;

public class AnchorPaneDemo extends Application {

    @Override
    public void start(Stage stage) throws Exception {
        // FXMLをロードする場合
//        AnchorPane anchorPane = FXMLLoader.load(getClass().getResource("AnchorPaneDemoView.fxml"));
        
        AnchorPane anchorPane = new AnchorPane();
        anchorPane.setPrefSize(400, 300);

        Button button0 = new Button("Button: Top & Left are anchored");
        AnchorPane.setLeftAnchor(button0, 20.0);
        AnchorPane.setTopAnchor(button0, 20.0);
        anchorPane.getChildren().add(button0);

        Button button1 = new Button("Button: Bottom & Right are anchored");
        AnchorPane.setRightAnchor(button1, 20.0);
        AnchorPane.setBottomAnchor(button1, 20.0);
        anchorPane.getChildren().add(button1);

        Button button2 = new Button("Button: Top, Left & Right are anchored");
        AnchorPane.setLeftAnchor(button2, 60.0);
        AnchorPane.setRightAnchor(button2, 60.0);
        AnchorPane.setTopAnchor(button2, 60.0);
        anchorPane.getChildren().add(button2);

        Button button3 = new Button("Button: Top, Bottom, Left & Right are anchored");
        AnchorPane.setLeftAnchor(button3, 60.0);
        AnchorPane.setRightAnchor(button3, 60.0);
        AnchorPane.setTopAnchor(button3, 120.0);
        AnchorPane.setBottomAnchor(button3, 120.0);
        anchorPane.getChildren().add(button3);

        Scene scene = new Scene(anchorPane);

        stage.setTitle("AnchorPane Demo");
        stage.setScene(scene);
        stage.show();
    }

    public static void main(String[] args) {
        launch(args);
    }
}
