
import javafx.application.Application;
import javafx.geometry.Insets;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.layout.ColumnConstraints;
import javafx.scene.layout.GridPane;
import javafx.scene.layout.RowConstraints;
import javafx.stage.Stage;

public class GridPaneDemo extends Application {

    @Override
    public void start(Stage stage) {
        GridPane gridPane = new GridPane();
        gridPane.setPrefSize(400, 300);
        gridPane.setPadding(new Insets(10));
        gridPane.setHgap(10);
        gridPane.setVgap(10);
        
//        initButtons1(gridPane);
        initButtons2(gridPane);
        Scene scene = new Scene(gridPane);

        stage.setTitle("GridPane Demo");
        stage.setScene(scene);
        stage.show();
    }
    
    private void initButtons1(GridPane gridPane) {
        // 4×5のグリッドにボタンを配置
        for (int i = 0; i < 5; i++) {
            for (int j = 0; j < 4; j++) {
                Button button = new Button("Button" + j + "-" + i);

                // 以下の3種類のいずれの手法でもレイアウト結果は同一
                GridPane.setColumnIndex(button, j);
                GridPane.setRowIndex(button, i);
                gridPane.getChildren().add(button);

//                GridPane.setConstraints(button, j, i);
//                gridPane.getChildren().add(button);
                
//                gridPane.add(button, j, i);
            }
        }
    }
    
    private void initButtons2(GridPane gridPane) {
        Button button = new Button("Button0-0");
        button.setPrefSize(400, 400);
        gridPane.add(button, 0, 0, 3, 1);

        button = new Button("Button3-0");
        button.setPrefSize(400, 400);
        gridPane.add(button, 3, 0);
        
        button = new Button("Button0-1");
        button.setPrefSize(400, 400);
        gridPane.add(button, 0, 1, 1, 2);

        button = new Button("Button1-1");
        button.setPrefSize(400, 400);
        gridPane.add(button, 1, 1);

        button = new Button("Button2-1");
        button.setPrefSize(400, 400);
        gridPane.add(button, 2, 1, 2, 2);
        
        button = new Button("Button1-2");
        button.setPrefSize(400, 400);
        gridPane.add(button, 1, 2);

        button = new Button("Button0-3");
        button.setPrefSize(400, 400);
        gridPane.add(button, 0, 3, 2, 1);

        button = new Button("Button2-3");
        button.setPrefSize(400, 400);
        gridPane.add(button, 2, 3);

        button = new Button("Button3-3");
        button.setPrefSize(400, 400);
        gridPane.add(button, 3, 3);
    }

    public static void main(String[] args) {
        launch(args);
    }
}
