

import javafx.application.Application;
import javafx.collections.ObservableList;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.fxml.FXMLLoader;
import javafx.geometry.Insets;
import javafx.geometry.Pos;
import javafx.scene.Node;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.layout.BorderPane;
import javafx.scene.layout.StackPane;
import javafx.stage.Stage;

public class StackPaneDemo extends Application {
    
    // StackPaneオブジェクトで保持するノード
    private ObservableList<Node> children;
    
    @Override
    public void start(Stage stage) throws Exception {
        // FXMLを使用する場合
//        BorderPane root = FXMLLoader.load(getClass().getResource("StackPaneDemoView.fxml"));

        BorderPane root = new BorderPane();
        root.setPrefSize(320, 240);
        
        StackPane stackPane = new StackPane();
        stackPane.setPrefSize(320, 213);
        BorderPane.setAlignment(stackPane, Pos.TOP_CENTER);
        root.setCenter(stackPane);

        children = stackPane.getChildren();
        
        // 5枚のイメージを追加する
        for (int i = 0; i < 5; i++) {
            ImageView image = new ImageView(new Image("image"+i+".jpg"));
            children.add(image);
        }
        
        // 重ね順を変更するためのボタン
        Button nextButton = new Button("NEXTT");
        BorderPane.setAlignment(nextButton, Pos.CENTER);
        BorderPane.setMargin(nextButton, new Insets(4));
        root.setBottom(nextButton);
        
        // ボタンが押された時のイベント処理
        nextButton.setOnAction(new EventHandler<ActionEvent>() {
            @Override
            public void handle(ActionEvent event) {
                // 一番手前に表示されているノードを削除し、
                // 一番奥に追加する
                Node node = children.remove(children.size() - 1);
                children.add(0, node);
            }
        });
        
        Scene scene = new Scene(root);
        stage.setTitle("StackPane Demo");
        stage.setScene(scene);
        stage.show();
    }

    public static void main(String[] args) {
        launch(args);
    }
}
