

import javafx.application.Application;
import javafx.fxml.FXMLLoader;
import javafx.geometry.Pos;
import javafx.scene.Scene;
import javafx.scene.layout.StackPane;
import javafx.scene.paint.Color;
import javafx.scene.shape.Circle;
import javafx.stage.Stage;

public class StackedCircleDemo extends Application {
    
    @Override
    public void start(Stage stage) throws Exception {
        // FXML で読み込む場合
//        StackPane stackPane = FXMLLoader.load(getClass().getResource("StackedCircleView.fxml"));

        StackPane stackPane = new StackPane();
        stackPane.setPrefSize(400, 400);
        stackPane.setAlignment(Pos.TOP_LEFT);
        
        for (int i = 10; i > 0; i--) {
            // 半径が 50+i*10 の円
            Circle circle = new Circle(50 + i * 10);
            // 赤から青に色が変化するようにする
            circle.setFill(Color.color(1.0 - i / 10.0, 0, i / 10.0));
            // 先に追加したものが奥に表示される
            stackPane.getChildren().add(circle);
        }
        
        Scene scene = new Scene(stackPane);
        
        stage.setTitle("Stacked Circle Demo");
        stage.setScene(scene);
        stage.show();
    }

    public static void main(String[] args) {
        launch(args);
    }
}
